! Subroutine to do Jacobi iteration
subroutine jacobi(a,b,x,n,nit_max,eps,xg,converged)
integer,intent(in) :: n,nit_max
real,intent(in) :: eps
real,intent(in) :: a(n,n),b(n)
real,intent(inout) :: xg(n)
real,intent(out) :: x(n)
logical,intent(inout) :: converged
integer :: i,j,k
real :: error = 1.0e5,z
k = 0

do while ( k .le. nit_max .and. error .ge. eps)
  k = k+ 1
  error = 0.0
  do i = 1,n
    z= 0.0
    do j = 1,n
      if (i .ne. j) then
        z = z + a(i,j)*xg(j)
      endif
    enddo
    x(i) = (b(i) - z )/a(i,i)
! find the error
    error = error + abs(x(i) - xg(i))
  enddo
  xg = x
  write(*,*)'k,x,error',k,x,error
enddo

if ( k .gt. nit_max .or. error .ge. eps) then
 converged = .false.
else
 converged = .true.
endif
return
end

! program jacobi_driver
integer :: n,nit_max
real :: eps
parameter (n=3,nit_max=100,eps=1.0e-3)
real :: a(n,n),b(n),x(n),xg(n)    
logical :: converged = .false. 
data a/2.0,1.0,4.0,-1.0,6.0,-3.0,0.0,-2.0,8.0/
data b/2.0,-4.0,5.0/
call jacobi(a,b,x,n,nit_max,eps,xg,converged)
write(*,*)'converged',converged
write(*,*)'x',x
stop
end
   

